#region Using declarations
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Input;
using System.Windows.Media;
using System.Xml.Serialization;
using NinjaTrader.Cbi;
using NinjaTrader.Gui;
using NinjaTrader.Gui.Chart;
using NinjaTrader.Gui.SuperDom;
using NinjaTrader.Gui.Tools;
using NinjaTrader.Data;
using NinjaTrader.NinjaScript;
using NinjaTrader.Core.FloatingPoint;

#endregion



#region NinjaScript generated code. Neither change nor remove.

namespace NinjaTrader.NinjaScript.Indicators
{
	public partial class Indicator : NinjaTrader.Gui.NinjaScript.IndicatorRenderBase
	{
		
		private BuySideGlobal.BSGSupplyDemand[] cacheBSGSupplyDemand;

		
		public BuySideGlobal.BSGSupplyDemand BSGSupplyDemand(Brush supplyStrong, Brush supplyRetouch, Brush supplyZoneBorder, Brush demandStrong, Brush demandRetouch, Brush demandZoneBorder, Brush textColor, int strongOpacity, int retouchOpacity, bool showHistory, bool showOnlyPriorZones, bool recolorRetouch, bool extendZone, bool displayZoneConfirm, int extendZoneMinutes, int priorZoneDaysBack, bool farEdgePrice, bool mainEdgePrice, bool zoneHeight, bool retestEnabled, string retestAlert)
		{
			return BSGSupplyDemand(Input, supplyStrong, supplyRetouch, supplyZoneBorder, demandStrong, demandRetouch, demandZoneBorder, textColor, strongOpacity, retouchOpacity, showHistory, showOnlyPriorZones, recolorRetouch, extendZone, displayZoneConfirm, extendZoneMinutes, priorZoneDaysBack, farEdgePrice, mainEdgePrice, zoneHeight, retestEnabled, retestAlert);
		}


		
		public BuySideGlobal.BSGSupplyDemand BSGSupplyDemand(ISeries<double> input, Brush supplyStrong, Brush supplyRetouch, Brush supplyZoneBorder, Brush demandStrong, Brush demandRetouch, Brush demandZoneBorder, Brush textColor, int strongOpacity, int retouchOpacity, bool showHistory, bool showOnlyPriorZones, bool recolorRetouch, bool extendZone, bool displayZoneConfirm, int extendZoneMinutes, int priorZoneDaysBack, bool farEdgePrice, bool mainEdgePrice, bool zoneHeight, bool retestEnabled, string retestAlert)
		{
			if (cacheBSGSupplyDemand != null)
				for (int idx = 0; idx < cacheBSGSupplyDemand.Length; idx++)
					if (cacheBSGSupplyDemand[idx].SupplyStrong == supplyStrong && cacheBSGSupplyDemand[idx].SupplyRetouch == supplyRetouch && cacheBSGSupplyDemand[idx].SupplyZoneBorder == supplyZoneBorder && cacheBSGSupplyDemand[idx].DemandStrong == demandStrong && cacheBSGSupplyDemand[idx].DemandRetouch == demandRetouch && cacheBSGSupplyDemand[idx].DemandZoneBorder == demandZoneBorder && cacheBSGSupplyDemand[idx].TextColor == textColor && cacheBSGSupplyDemand[idx].StrongOpacity == strongOpacity && cacheBSGSupplyDemand[idx].RetouchOpacity == retouchOpacity && cacheBSGSupplyDemand[idx].ShowHistory == showHistory && cacheBSGSupplyDemand[idx].ShowOnlyPriorZones == showOnlyPriorZones && cacheBSGSupplyDemand[idx].RecolorRetouch == recolorRetouch && cacheBSGSupplyDemand[idx].ExtendZone == extendZone && cacheBSGSupplyDemand[idx].DisplayZoneConfirm == displayZoneConfirm && cacheBSGSupplyDemand[idx].ExtendZoneMinutes == extendZoneMinutes && cacheBSGSupplyDemand[idx].PriorZoneDaysBack == priorZoneDaysBack && cacheBSGSupplyDemand[idx].FarEdgePrice == farEdgePrice && cacheBSGSupplyDemand[idx].MainEdgePrice == mainEdgePrice && cacheBSGSupplyDemand[idx].ZoneHeight == zoneHeight && cacheBSGSupplyDemand[idx].RetestEnabled == retestEnabled && cacheBSGSupplyDemand[idx].RetestAlert == retestAlert && cacheBSGSupplyDemand[idx].EqualsInput(input))
						return cacheBSGSupplyDemand[idx];
			return CacheIndicator<BuySideGlobal.BSGSupplyDemand>(new BuySideGlobal.BSGSupplyDemand(){ SupplyStrong = supplyStrong, SupplyRetouch = supplyRetouch, SupplyZoneBorder = supplyZoneBorder, DemandStrong = demandStrong, DemandRetouch = demandRetouch, DemandZoneBorder = demandZoneBorder, TextColor = textColor, StrongOpacity = strongOpacity, RetouchOpacity = retouchOpacity, ShowHistory = showHistory, ShowOnlyPriorZones = showOnlyPriorZones, RecolorRetouch = recolorRetouch, ExtendZone = extendZone, DisplayZoneConfirm = displayZoneConfirm, ExtendZoneMinutes = extendZoneMinutes, PriorZoneDaysBack = priorZoneDaysBack, FarEdgePrice = farEdgePrice, MainEdgePrice = mainEdgePrice, ZoneHeight = zoneHeight, RetestEnabled = retestEnabled, RetestAlert = retestAlert }, input, ref cacheBSGSupplyDemand);
		}

	}
}

namespace NinjaTrader.NinjaScript.MarketAnalyzerColumns
{
	public partial class MarketAnalyzerColumn : MarketAnalyzerColumnBase
	{
		
		public Indicators.BuySideGlobal.BSGSupplyDemand BSGSupplyDemand(Brush supplyStrong, Brush supplyRetouch, Brush supplyZoneBorder, Brush demandStrong, Brush demandRetouch, Brush demandZoneBorder, Brush textColor, int strongOpacity, int retouchOpacity, bool showHistory, bool showOnlyPriorZones, bool recolorRetouch, bool extendZone, bool displayZoneConfirm, int extendZoneMinutes, int priorZoneDaysBack, bool farEdgePrice, bool mainEdgePrice, bool zoneHeight, bool retestEnabled, string retestAlert)
		{
			return indicator.BSGSupplyDemand(Input, supplyStrong, supplyRetouch, supplyZoneBorder, demandStrong, demandRetouch, demandZoneBorder, textColor, strongOpacity, retouchOpacity, showHistory, showOnlyPriorZones, recolorRetouch, extendZone, displayZoneConfirm, extendZoneMinutes, priorZoneDaysBack, farEdgePrice, mainEdgePrice, zoneHeight, retestEnabled, retestAlert);
		}


		
		public Indicators.BuySideGlobal.BSGSupplyDemand BSGSupplyDemand(ISeries<double> input , Brush supplyStrong, Brush supplyRetouch, Brush supplyZoneBorder, Brush demandStrong, Brush demandRetouch, Brush demandZoneBorder, Brush textColor, int strongOpacity, int retouchOpacity, bool showHistory, bool showOnlyPriorZones, bool recolorRetouch, bool extendZone, bool displayZoneConfirm, int extendZoneMinutes, int priorZoneDaysBack, bool farEdgePrice, bool mainEdgePrice, bool zoneHeight, bool retestEnabled, string retestAlert)
		{
			return indicator.BSGSupplyDemand(input, supplyStrong, supplyRetouch, supplyZoneBorder, demandStrong, demandRetouch, demandZoneBorder, textColor, strongOpacity, retouchOpacity, showHistory, showOnlyPriorZones, recolorRetouch, extendZone, displayZoneConfirm, extendZoneMinutes, priorZoneDaysBack, farEdgePrice, mainEdgePrice, zoneHeight, retestEnabled, retestAlert);
		}
	
	}
}

namespace NinjaTrader.NinjaScript.Strategies
{
	public partial class Strategy : NinjaTrader.Gui.NinjaScript.StrategyRenderBase
	{
		
		public Indicators.BuySideGlobal.BSGSupplyDemand BSGSupplyDemand(Brush supplyStrong, Brush supplyRetouch, Brush supplyZoneBorder, Brush demandStrong, Brush demandRetouch, Brush demandZoneBorder, Brush textColor, int strongOpacity, int retouchOpacity, bool showHistory, bool showOnlyPriorZones, bool recolorRetouch, bool extendZone, bool displayZoneConfirm, int extendZoneMinutes, int priorZoneDaysBack, bool farEdgePrice, bool mainEdgePrice, bool zoneHeight, bool retestEnabled, string retestAlert)
		{
			return indicator.BSGSupplyDemand(Input, supplyStrong, supplyRetouch, supplyZoneBorder, demandStrong, demandRetouch, demandZoneBorder, textColor, strongOpacity, retouchOpacity, showHistory, showOnlyPriorZones, recolorRetouch, extendZone, displayZoneConfirm, extendZoneMinutes, priorZoneDaysBack, farEdgePrice, mainEdgePrice, zoneHeight, retestEnabled, retestAlert);
		}


		
		public Indicators.BuySideGlobal.BSGSupplyDemand BSGSupplyDemand(ISeries<double> input , Brush supplyStrong, Brush supplyRetouch, Brush supplyZoneBorder, Brush demandStrong, Brush demandRetouch, Brush demandZoneBorder, Brush textColor, int strongOpacity, int retouchOpacity, bool showHistory, bool showOnlyPriorZones, bool recolorRetouch, bool extendZone, bool displayZoneConfirm, int extendZoneMinutes, int priorZoneDaysBack, bool farEdgePrice, bool mainEdgePrice, bool zoneHeight, bool retestEnabled, string retestAlert)
		{
			return indicator.BSGSupplyDemand(input, supplyStrong, supplyRetouch, supplyZoneBorder, demandStrong, demandRetouch, demandZoneBorder, textColor, strongOpacity, retouchOpacity, showHistory, showOnlyPriorZones, recolorRetouch, extendZone, displayZoneConfirm, extendZoneMinutes, priorZoneDaysBack, farEdgePrice, mainEdgePrice, zoneHeight, retestEnabled, retestAlert);
		}

	}
}

#endregion
